﻿using System;
using System.Collections.Generic;
using TheGameExtreme.model.card;

namespace TheGameExtreme.model.gameActions.classic
{
    public class JouerUneCarte : GameAction
    {

        public JouerUneCarte(Piles ListOrderedStacks) : base(ListOrderedStacks)
        {
        }

        public void play(int valueCard, List<Card> CurrentHand, int orderedStackSelected, Player player, List<Card> CurrentCardPlayed)
        {
            foreach (Card card in CurrentHand)
            {
                if (valueCard == card.Value)
                {
                    if (orderedStackSelected >= 0 && orderedStackSelected < 4)
                    {
                        if (orderedStackSelected < 2)
                        {
                            rule(card, ListOrderedStacks.getStack(orderedStackSelected), true, player, CurrentCardPlayed);
                        }
                        else
                        {
                            rule(card, ListOrderedStacks.getStack(orderedStackSelected), false, player, CurrentCardPlayed);
                        }
                    }
                    else
                    {
                        throw new Exception(AppRessource.StrCantGetStack);
                    }
                    return;
                }
            }
        }

        private void rule(Card card, Stack<Card> stack, bool bottomUp, Player player, List<Card> CurrentCardPlayed)
        {
            if ((bottomUp && card.Value > stack.Peek().Value) || (!bottomUp && card.Value < stack.Peek().Value) || card.Value == stack.Peek().Value - 10 || card.Value == stack.Peek().Value + 10)
            {
                Card oldCard = stack.Peek();
                player.joue(card);
                CurrentCardPlayed.Add(card);
                stack.Push(card);
                //OnTopRangeChanged(new TopRangeChangedEventArgs(card, oldCard, ListOrderedStacks.IndexOf(orderedStack)));
            }
            else
            {
                throw new Exception(AppRessource.StrWrongStack);
            }
            //if (EndMessage != null)
            //{
            //    //throw new Exception("Le jeu est fini! Veuillez lancer une nouvelle partie!");
            //    throw new Exception(AppRessource.StrEndOfGame);
            //}
        }
    }
}
